using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Collections;
using System.Collections.Specialized;
using System.Net;

namespace Toolkit.App {
	/// <summary>
	/// G[񍐏
	/// </summary>
	public class ErrorReporter {
		/// <summary>
		/// SingletonȃCX^X̎擾
		/// </summary>
		public static ErrorReporter Instance {
			get {
				return Singleton<ErrorReporter>.GetInstance(delegate() {
					return new ErrorReporter();
				});
			}
		}

		string url = "http://tqzh.tk:24497/site/error/";
		Dictionary<string, string> additionalInfo = new Dictionary<string, string>();
		Control owner = null;

		object lockObject = new object();
		bool localLock = false;

		private ErrorReporter() {
			// ftHgœo^Ă܂H
			//Register();
		}

		/// <summary>
		/// MURL
		/// </summary>
		public string URL {
			get { return url; }
			set { url = value; }
		}

		/// <summary>
		/// I[i[EBhE
		/// </summary>
		public Control Owner {
			get { return owner; }
			set { owner = value; }
		}

		/// <summary>
		/// formOwnerɓo^B
		/// </summary>
		public void SetOwner(Control form) {
			owner = form;
			form.Disposed += new EventHandler(form_Disposed);
		}

		/// <summary>
		/// AvP[VŗL̒ǉ
		/// </summary>
		public Dictionary<string, string> AdditionalInfo {
			get { return additionalInfo; }
		}

		/// <summary>
		/// AvP[V̍ċNsB
		/// KׂB
		/// </summary>
		public event EventHandler RestartApplication;

		/// <summary>
		/// AvP[V̏IsB
		/// KׂB
		/// </summary>
		/// <remarks>
		/// Application.Exit()邾łCcB
		/// </remarks>
		public event EventHandler ExitApplication;

		/// <summary>
		/// nho^B
		/// </summary>
		public void Register() {
			//*
			Application.ThreadException += new ThreadExceptionEventHandler(Application_ThreadException);
			/*/
			Thread.GetDomain().UnhandledException += new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);
			//*/
		}

		/// <summary>
		/// nho^B
		/// </summary>
		public void UnRegister() {
			//*
			Application.ThreadException -= new ThreadExceptionEventHandler(Application_ThreadException);
			/*/
			Thread.GetDomain().UnhandledException -= new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);
			//*/
		}

		void form_Disposed(object sender, EventArgs e) {
			owner = null;
		}

		/// <summary>
		/// gbvȂOƌĂяoCxgB
		/// </summary>
		void Application_ThreadException(object sender, ThreadExceptionEventArgs e) {
			OnException(e.Exception);
		}

		/// <summary>
		/// Oɑ΂鏈
		/// </summary>
		/// <param name="e">OIuWFNg</param>
		public void OnException(Exception e) {
			lock (lockObject) {
				if (localLock) {
					//System.Diagnostics.Process.GetCurrentProcess().Kill();
					return;
				}
				localLock = true;
			}
			try {
				switch (ShowReporterForm(e)) {
				case DialogResult.Abort: // I
					ExitApplication(this, EventArgs.Empty);
					break;
				case DialogResult.Retry: // ċN
					RestartApplication(this, EventArgs.Empty);
					break;
				case DialogResult.None:
				case DialogResult.Ignore: // s
					break;
				}
			} catch (Exception ex) {
				System.Diagnostics.Debug.Fail(ex.ToString());
				// ɍċAƖʓ|Ȃ̂ŁBB
			} finally {
				localLock = false;
			}
		}

		/// <summary>
		/// ErrorReporterForm\
		/// </summary>
		private DialogResult ShowReporterForm(Exception ex) {
			using (ErrorReporterForm form = new ErrorReporterForm(ex)) {
				if (owner != null) {
					if (owner.Visible) {
						form.StartPosition = FormStartPosition.CenterParent;
					}
					return form.ShowDialog(owner);
				}
				return form.ShowDialog();
			}
		}

		/// <summary>
		/// G[|[g̑M
		/// </summary>
		/// <param name="e">OIuWFNg</param>
		public void SendReport(Exception e) {
			NameValueCollection c = new NameValueCollection();
			c["Message"] = e.Message.Trim();
			c["Details"] = GetDetailMessage(e).Trim();
			c["ExceptionData"] = Serialize(e.Data).Trim();
			c["AdditionalInfo"] = Serialize(additionalInfo).Trim();
			c["ApplicationInfo"] = System.Diagnostics.Process.GetCurrentProcess()
				.MainModule.FileVersionInfo.ToString();
			c["ExeLastUpdate"] = System.IO.File.GetLastWriteTime(
				System.Diagnostics.Process.GetCurrentProcess().MainModule.FileName).ToString("yyyy-MM-dd HH:mm:ss");
			c["StackTrace"] = e.StackTrace;

			using (WebClient client = new WebClient()) {
				client.Proxy = WebRequest.GetSystemWebProxy(); // ߂ǂRɌߑłB
				client.UploadValues(url, c);
			}
		}

		/// <summary>
		/// Ȍڍ׃bZ[WgݗĂĕԂ
		/// </summary>
		public string GetDetailMessage(Exception e) {
			StringBuilder builder = new StringBuilder();
			AppendExceptionString(builder, e);
			return builder.ToString();
		}

		private static void AppendExceptionString(StringBuilder builder, Exception e) {
			builder.Append(e.GetType().ToString());
			builder.AppendLine(":");
			if (e.Message != null) {
				builder.AppendLine(e.Message.TrimEnd());
				builder.AppendLine();
			}
			if (e.StackTrace != null) {
				builder.AppendLine("X^bNg[X:");
				builder.AppendLine(e.StackTrace.TrimEnd());
				builder.AppendLine();
			}
			if (e.Source != null) {
				builder.AppendLine("\[X:");
				builder.AppendLine(e.Source);
				builder.AppendLine();
			}
			Exception ie = e.InnerException;
			if (ie != null) {
				builder.Append("InnerException -> ");
				AppendExceptionString(builder, ie);
				builder.AppendLine(" <- InnerException");
			}
			Exception be = e.GetBaseException();
			if (be != null && be != ie && !object.Equals(be, e)) { // H(L`)
				builder.Append("BaseException -> ");
				AppendExceptionString(builder, ie);
				builder.Append(" <- BaseException");
			}
		}

		private static string Serialize(IDictionary data) {
			//return Serializer<List<string>>.SerializeToString(Convert(data));
			return string.Join(Environment.NewLine, Convert(data).ToArray());
		}
		private static List<string> Convert(IDictionary data) {
			List<string> result = new List<string>();
			foreach (DictionaryEntry p in data) {
				result.Add(string.Format("{0}: {1}", p.Key.ToString().Trim(), p.Value.ToString().Trim()));
			}
			return result;
		}

	}
}
