using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.IO;

namespace CommonArchiverLibrary
{
    /// <summary>
    /// A[JCoAPIdlɏDLL̈Ⴂɂ炸ɂ쐬AWJNX
    /// </summary>
    public class Archiver : CommonArchiver
    {
        private string _extractAllCommand = "";
        /// <summary>
        /// ɓ̃t@CׂēWJ鎞ɎgpR}hC̏
        /// </summary>
        public string ExtractAllCommand
        {
            get
            {
                return this._extractAllCommand;
            }
        }

        private string _compressCommand = "";
        /// <summary>
        /// ɂ쐬鎞ɎgpR}hC̏
        /// </summary>
        public string CompressCommand
        {
            get
            {
                return this._compressCommand;
            }
        }

        private string _allFilesPattern = "*";
        /// <summary>
        /// ׂẴt@C\ChJ[h
        /// </summary>
        public string AllFilesPattern
        {
            get
            {
                return this._allFilesPattern;
            }
            set
            {
                this._allFilesPattern = value;
            }
        }

        private string[] _extensions = null;
        /// <summary>
        /// Ƃ̂ł鏑ɂ̊gq
        /// </summary>
        public string[] Extensions
        {
            get
            {
                return this._extensions;
            }
        }

        private string _defaultExtension = "";
        /// <summary>
        /// ɂ쐬ɕtgq
        /// </summary>
        public string DefaultExtension
        {
            get
            {
                return this._defaultExtension;
            }
        }

        private int _minimumVersion = 0;
        /// <summary>
        /// DLLɍŒKvȃo[W
        /// </summary>
        public int MinimumVersion
        {
            get
            {
                return this._minimumVersion;
            }
        }

        private string _description = "";
        /// <summary>
        /// ̕
        /// </summary>
        public string Description
        {
            get
            {
                return this._description;
            }
        }

        private int _maxCommandFiles = -1;
        /// <summary>
        /// X|Xt@CȂt@C̍ől
        /// -1ŃX|Xt@CȂ
        /// </summary>
        public int MaxCommandFiles
        {
            get
            {
                return this._maxCommandFiles;
            }
        }


        protected string _outputBuffer = "";
        /// <summary>
        /// sAo͂ꂽ
        /// </summary>
        public string OutputBuffer
        {
            get
            {
                return this._outputBuffer;
            }
        }

        /// <summary>
        /// o̓obt@̃TCY
        /// </summary>
        protected int OutputBufferLength = 1024;

        /// <summary>
        /// o[Wi݂͏2[ĥ݁j擾
        /// </summary>
        public string Version
        {
            get
            {
                try
                {
                    return (this.GetVersion() / 100f).ToString("0.00");
                }
                catch
                {
                    return "";
                }
            }
        }

        /// <summary>
        /// DLLCXg[Ă邩
        /// </summary>
        public virtual bool IsInstalled
        {
            get
            {
                try
                {
                    uint ver = this.GetVersion();
                    if ((uint)this.MinimumVersion > ver)
                        return false;
                    else
                        return true;
                }
                catch
                {
                    return false;
                }
            }
        }

        /// <summary>
        /// DLLs
        /// </summary>
        public bool IsRunning
        {
            get
            {
                try
                {
                    return this.GetRunning();
                }
                catch
                {
                    return false;
                }
            }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="arcSet">DLL̐ݒ</param>
        public Archiver(ArchiverSetting arcSet)
            : base(arcSet.DllName, arcSet.FunctionName)
        {
            this._extractAllCommand = arcSet.ExtractAllCommand;
            this._compressCommand = arcSet.CompressCommand;
            this._allFilesPattern = arcSet.AllFilePattern;
            this._extensions = arcSet.Extensions;
            this._defaultExtension = arcSet.DefaultExtension;
            this._minimumVersion = arcSet.MinVersion;
            this._maxCommandFiles = arcSet.MaxCommandFiles;
            this._description = arcSet.Description;
        }

        public Archiver(string dllName, string funcName,
            string extractCmd, string compressCmd,
            string defaultExt)
            : base(dllName, funcName)
        {
            this._extractAllCommand = extractCmd;
            this._compressCommand = compressCmd;
            this._defaultExtension = defaultExt;
            this._extensions = new string[] { defaultExt };
        }

        /// <summary>
        /// ɂ̓WJɑΉĂ邩
        /// </summary>
        /// <remarks>
        /// ̃IuWFNgɂ̓WJɑΉĂ邩̂łāA
        /// CXg[Ă邩܂߁AۂɓWJł邩̂ł͂ȂB
        /// </remarks>
        /// <returns>trueœWJɑΉĂ</returns>
        public virtual bool CanExtract()
        {
            return !string.IsNullOrEmpty(this.ExtractAllCommand);
        }

        /// <summary>
        /// ɂ̍쐬ɑΉĂ邩
        /// </summary>
        /// <remarks>
        /// ̃IuWFNgɂ̍쐬ɑΉĂ邩̂łāA
        /// CXg[Ă邩܂߁Aۂɏɂ쐬ł邩̂ł͂ȂB
        /// </remarks>
        /// <returns>trueŏɂ̍쐬ɑΉĂ</returns>
        public virtual bool CanCompress()
        {
            return !string.IsNullOrEmpty(this.CompressCommand);
        }

        /// <summary>
        /// w肵t@C̓WJɑΉĂ邩
        /// </summary>
        /// <param name="fileName">`FbN鏑</param>
        /// <returns>trueœWJ\</returns>
        public virtual bool CanExtract(string fileName)
        {
            if (!this.CanExtract())
                return false;

            try
            {
                return this.CheckArchive(fileName, 0);
            }
            catch
            {
                return false;
            }
        }

        /// <summary>
        /// t@CR}hɎwł`ɕϊ
        /// </summary>
        /// <param name="fileName">t@C</param>
        /// <param name="isDir">fileNamefBNgǂ</param>
        /// <returns>R}hƂĂ̕</returns>
        protected virtual string ToCommandStringFromFile(string fileName, bool isDir)
        {
            string cmd = fileName;
            //fBNg̎́AׂẴt@C̃ChJ[ht
            if (isDir)
            {
                cmd = Path.Combine(fileName, this.AllFilesPattern);
            }
            //"-","@"Ŏn܂t@C̏
            if (cmd.StartsWith("-") || cmd.StartsWith("@"))
            {
                cmd = ".\\" + cmd;
            }
            //"Ŋ
            if (cmd.IndexOf(' ') != -1 && !cmd.StartsWith("\"") && !cmd.EndsWith("\""))
            {
                cmd = "\"" + cmd + "\"";
            }

            return cmd;
        }
        /// <summary>
        /// t@CR}hɎwł`ɕϊ
        /// </summary>
        /// <param name="fileName">t@C</param>
        /// <returns>R}hƂĂ̕</returns>
        protected string ToCommandStringFromFile(string fileName)
        {
            return this.ToCommandStringFromFile(fileName, false);
        }

        /// <summary>
        /// fBNgR}hɎwł`ɕϊ
        /// </summary>
        /// <param name="dirName">fBNg</param>
        /// <returns>R}hƂĂ̕</returns>
        protected virtual string ToCommandStringFromDirectory(string dirName)
        {
            string cmd = dirName;
            //fBNg̎́AŌ"\"
            if (!cmd.EndsWith("\\"))
            {
                cmd += "\\";
            }
            //"Ŋ
            if (cmd.IndexOf(' ') != -1 && !cmd.StartsWith("\"") && !cmd.EndsWith("\""))
            {
                cmd = "\"" + cmd + "\"";
            }

            return cmd;
        }

        /// <summary>
        /// ɓׂ̂Ẵt@CWJ
        /// </summary>
        /// <param name="archiveFile">WJ鏑ɂ̃pX</param>
        /// <param name="baseDir">WJ̃tH_</param>
        /// <param name="ownerHandle">EBhEnh</param>
        public virtual void ExtractAll(string archiveFile, string extractTo,
            IntPtr ownerHandle)
        {
            this._outputBuffer = "";

            //w肳ꂽt@C邩ׂ
            if (!System.IO.File.Exists(archiveFile))
            {
                throw new ApplicationException(
                    string.Format("w肳ꂽt@C'{0}'݂܂B",
                    archiveFile));
            }

            //DLLCXg[Ă邩mF
            if (!this.IsInstalled)
            {
                throw new ApplicationException(
                    string.Format("DLL'{0}'CXg[Ă܂B",
                    this.DllFileName));
            }

            //DLLsmF
            if (this.IsRunning)
            {
                throw new ApplicationException(
                    string.Format("DLL'{0}'słB",
                    this.DllFileName));
            }

            //WJłt@Cׂ
            if (!this.CanExtract(archiveFile))
            {
                throw new ApplicationException(
                    string.Format("w肳ꂽt@C'{0}'{1}ł͓WJł܂B",
                    archiveFile, this.DllFileName));
            }

            //WJtH_̍쐬
            DirectoryInfo createdDir = null;
            if (!Directory.Exists(extractTo))
            {
                createdDir = Directory.CreateDirectory(extractTo);
            }

            //R}hC̍쐬
            string cmd = this.ExtractAllCommand.Replace("{file}",
                ToCommandStringFromFile(archiveFile));
            cmd = cmd.Replace("{dir}",
                ToCommandStringFromDirectory(extractTo));

            StringBuilder output = new StringBuilder(this.OutputBufferLength);

            //WJ
            int ret = this.Execute(ownerHandle, cmd, output, (uint)output.Capacity);

            this._outputBuffer = output.ToString();

            if (ret != 0)
            {
                //WJtH_͍̎폜i폜łȂj
                if (createdDir != null && createdDir.GetFileSystemInfos().Length == 0)
                {
                    try
                    {
                        createdDir.Delete();
                    }
                    catch
                    {
                    }
                }
                throw new ApplicationException(
                    string.Format("{0}ɂ鏑'{1}'̓WJɎs܂B({2})",
                    this.DllFileName, archiveFile, ret));
            }
        }

        public virtual void ExtractAll(string archiveFile)
        {
            //ɂƓtH_ɁAtH_쐬ēWJ
            string extractTo = Path.Combine(
                Path.GetDirectoryName(archiveFile),
                Path.GetFileNameWithoutExtension(archiveFile));
            this.ExtractAll(archiveFile, extractTo);
        }

        public virtual void ExtractAll(string archiveFile, string extractTo)
        {
            this.ExtractAll(archiveFile, extractTo, IntPtr.Zero);
        }

        /// <summary>
        /// Ƀt@C쐬
        /// </summary>
        /// <param name="compressFiles">ɂɓt@CpX̔z</param>
        /// <param name="createArchive">쐬鏑Ƀt@ẼpX</param>
        /// <param name="baseDir">{fBNg</param>
        /// <param name="ownerHandle">EBhEnh</param>
        public virtual void Compress(
            string[] compressFiles, string createArchive, string baseDir,
            IntPtr ownerHandle)
        {
            //ɂVK쐬
            if (File.Exists(createArchive))
            {
                throw new ApplicationException(
                    string.Format("t@C'{0}'ɑ݂Ă܂B",
                    createArchive));
            }

            //DLLCXg[Ă邩mF
            if (!this.IsInstalled)
            {
                throw new ApplicationException(
                    string.Format("DLL'{0}'CXg[Ă܂B",
                    this.DllFileName));
            }

            //DLLsmF
            if (this.IsRunning)
            {
                throw new ApplicationException(
                    string.Format("DLL'{0}'słB",
                    this.DllFileName));
            }

            //R}hƂēnt@CList쐬
            string[] fileList = GetCommandFileList(compressFiles, baseDir);

            if (fileList.Length == 0)
            {
                throw new ApplicationException(
                    "kt@C܂B");
            }

            //kt@Cǂ̂悤ɃR}hƂēn
            string compressFilePath = "";
            string responseFile = "";
            if (this.MaxCommandFiles < 0 || this._maxCommandFiles >= fileList.Length)
            {
                //̂܂܃R}hƂ
                compressFilePath = string.Join(" ", fileList);
            }
            else
            {
                //X|Xt@C
                responseFile = CreateResponseFile(fileList);
                compressFilePath = "\"@" + responseFile + "\"";
            }
            //{fBNgR}hCɒǉ
            if (!string.IsNullOrEmpty(baseDir))
                compressFilePath = ToCommandStringFromDirectory(baseDir) + " " + compressFilePath;

            //R}hC̍쐬
            string cmd = this.CompressCommand.Replace("{files}",
                compressFilePath);
            cmd = cmd.Replace("{archive}",
                ToCommandStringFromFile(createArchive));

            //k
            int ret = -1;
            StringBuilder output = new StringBuilder(this.OutputBufferLength);
            try
            {
                ret = this.Execute(ownerHandle, cmd, output, (uint)output.Capacity);
            }
            finally
            {
                //X|Xt@CƂ͍폜
                if (!string.IsNullOrEmpty(responseFile) && File.Exists(responseFile))
                    File.Delete(responseFile);
            }

            this._outputBuffer = output.ToString();

            if (ret != 0)
            {
                throw new ApplicationException(
                    string.Format("{0}ɂ鏑'{1}'̍쐬Ɏs܂B({2})",
                    this.DllFileName, createArchive, ret));
            }
        }

        public virtual void Compress(string[] compressFiles)
        {
            //kt@CƓtH_ɏɂ쐬
            string arcFile = "";
            if (compressFiles.Length > 0)
                arcFile = Path.ChangeExtension(compressFiles[0], this.DefaultExtension);
            this.Compress(compressFiles, arcFile);
        }

        public virtual void Compress(string[] compressFiles, string createArchive)
        {
            //kt@ĈtH_Ƃďɂ쐬
            string baseDir = "";
            if (compressFiles.Length > 0)
                baseDir = Path.GetDirectoryName(compressFiles[0]);
            this.Compress(compressFiles, createArchive, baseDir);
        }

        public virtual void Compress(string[] compressFiles, string createArchive, string baseDir)
        {
            this.Compress(compressFiles, createArchive, baseDir, IntPtr.Zero);
        }

        /// <summary>
        /// t@CpX̔zA
        /// {fBNggpăR}hƂĎgpł镶̔zɕϊ
        /// </summary>
        /// <param name="fileNames">t@CpX̔z</param>
        /// <param name="baseDir">{fBNg</param>
        /// <returns>R}hƂĎgpł镶̔z</returns>
        protected virtual string[] GetCommandFileList(string[] fileNames, string baseDir)
        {
            List<string> fileList = new List<string>();
            string filePath = "";
            bool isDir = false;
            if (!string.IsNullOrEmpty(baseDir) && !baseDir.EndsWith("\\"))
                baseDir += "\\";

            foreach (string f in fileNames)
            {
                filePath = f;
                isDir = Directory.Exists(f);

                //΃pXƂ
                if (!string.IsNullOrEmpty(baseDir))
                {
                    if (filePath.StartsWith(baseDir))
                        filePath = filePath.Substring(baseDir.Length);
                    else
                        throw new ApplicationException(
                            "w肳ꂽt@C'" + f + "'͊fBNg'" +
                            baseDir + "'̉ɂ܂B");
                }

                //Listɒǉ
                fileList.Add(ToCommandStringFromFile(filePath, isDir));
            }

            return fileList.ToArray();
        }

        /// <summary>
        /// X|Xt@C쐬
        /// </summary>
        /// <param name="files">t@CpXiR}hƂĐ`ς݁j̃Xg</param>
        /// <returns>쐬X|Xt@C</returns>
        protected virtual string CreateResponseFile(string[] files)
        {
            string resPath = Path.GetTempFileName();

            StreamWriter sw = null;
            try
            {
                sw = new StreamWriter(resPath, true,
                    System.Text.Encoding.GetEncoding("shift-jis"));
                {
                    foreach (string f in files)
                    {
                        sw.WriteLine(f);
                    }
                }
            }
            catch
            {
                //t@C폜
                if (sw != null)
                {
                    sw.Close();
                    sw = null;
                }
                File.Delete(resPath);
                throw;
            }
            finally
            {
                if (sw != null)
                    sw.Close();
            }

            return resPath;
        }
    }
}
