using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace CommonArchiverLibrary
{
    #region fQ[g
    //DLL ̔ł̎擾
    internal delegate ushort GetVersionDelegate();
    //DLL ̎s󋵂̎擾
    internal delegate bool GetRunningDelegate();
    //ɂ̃`FbN
    [UnmanagedFunctionPointer(
        CallingConvention.Winapi,
        CharSet = CharSet.Ansi)]
    internal delegate bool CheckArchiveDelegate(
        [MarshalAs(UnmanagedType.LPStr)]string _szFileName,
        int _iMode);
    //ɑ
    [UnmanagedFunctionPointer(
        CallingConvention.Winapi,
        CharSet = CharSet.Ansi)]
    internal delegate int ExecuteDelegate(
        IntPtr _hwnd,
        [MarshalAs(UnmanagedType.LPStr)]string _szCmdLine,
        [MarshalAs(UnmanagedType.LPStr)]StringBuilder _szOutput,
        uint _dwSize);
    #endregion

    /// <summary>
    /// A[JCoAPIdlɏDLLĂяo߂̃NX
    /// </summary>
    public class CommonArchiver : IDisposable
    {
        private string _dllFileName = "";
        /// <summary>
        /// DLLt@C
        /// </summary>
        public string DllFileName
        {
            get
            {
                return this._dllFileName;
            }
        }

        private string _executeFunctionName = "";
        /// <summary>
        /// R}hCsAPI
        /// </summary>
        public string ExecuteFunctionName
        {
            get
            {
                return this._executeFunctionName;
            }
        }

        private IntPtr _moduleHandle = IntPtr.Zero;
        /// <summary>
        /// DLLW[̃nh
        /// </summary>
        protected IntPtr ModuleHandle
        {
            get
            {
                if (this._moduleHandle == IntPtr.Zero)
                {
                    this.Load();
                }
                return this._moduleHandle;
            }
        }

        private Dictionary<string, Delegate> delegatesList =
            new Dictionary<string, Delegate>();

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="dllName">DLLt@C</param>
        /// <param name="funcName">R}hCsAPI</param>
        public CommonArchiver(string dllName, string funcName)
        {
            if (dllName.Length < 0)
                throw new ApplicationException("DLLt@Cw肳Ă܂B");
            if (funcName.Length < 0)
                throw new ApplicationException("{֐w肳Ă܂B");

            this._dllFileName = dllName;
            this._executeFunctionName = funcName;
        }

        #region IDisposable o
        /// <summary>
        /// 
        /// </summary>
        public virtual void Dispose()
        {
            this.Free();
        }
        #endregion

        /// <summary>
        /// DLL݂邩ׂ
        /// </summary>
        /// <returns></returns>
        public bool ExistsDll()
        {
            IntPtr pathPtr;
            return Win32.NativeMethods.SearchPath(
                null, this.DllFileName, null, 0, null, out pathPtr) != 0;
        }

        /// <summary>
        /// DLLǍ
        /// </summary>
        public void Load()
        {
            if (!this.ExistsDll())
                throw new ApplicationException(this.DllFileName + "݂܂B");

            IntPtr hmod = Win32.NativeMethods.LoadLibrary(this.DllFileName);
            if (hmod == IntPtr.Zero)
                throw new Win32Exception(Marshal.GetLastWin32Error());

            this._moduleHandle = hmod;
        }

        /// <summary>
        /// FreeLibraryĂяo
        /// </summary>
        public void Free()
        {
            if (this._moduleHandle != IntPtr.Zero)
            {
                Win32.NativeMethods.FreeLibrary(this._moduleHandle);
                this._moduleHandle = IntPtr.Zero;
            }
            this.delegatesList.Clear();
        }

        /// <summary>
        /// GetProcAddressɂA֐̃AhX擾
        /// </summary>
        /// <param name="funcSuffix">AhX擾API
        /// iExecuteFunctionNamevpeBj</param>
        /// <returns>AhX</returns>
        protected IntPtr GetFunctionAddress(string funcSuffix)
        {
            IntPtr funcAddr = Win32.NativeMethods.GetProcAddress(
                this.ModuleHandle,
                this.ExecuteFunctionName + funcSuffix);
            if (funcAddr == IntPtr.Zero)
            {
                //throw new Win32Exception(Marshal.GetLastWin32Error());
                throw new ApplicationException(
                    "w肳ꂽAPI'" + this.ExecuteFunctionName + funcSuffix + "'݂܂B");
            }
            return funcAddr;
        }

        #region A[JCoAPI
        public ushort GetVersion()
        {
            IntPtr funcAddr = this.GetFunctionAddress("GetVersion");
            GetVersionDelegate dlgt =
                (GetVersionDelegate)Marshal.GetDelegateForFunctionPointer(
                funcAddr, typeof(GetVersionDelegate));
            return dlgt();
        }

        public bool CheckArchive(string fileName, int mode)
        {
            IntPtr funcAddr = this.GetFunctionAddress("CheckArchive");
            CheckArchiveDelegate dlgt =
                (CheckArchiveDelegate)Marshal.GetDelegateForFunctionPointer(
                funcAddr, typeof(CheckArchiveDelegate));
            return dlgt(fileName, mode);
        }

        public bool GetRunning()
        {
            IntPtr funcAddr = this.GetFunctionAddress("GetRunning");
            GetRunningDelegate dlgt =
                (GetRunningDelegate)Marshal.GetDelegateForFunctionPointer(
                funcAddr, typeof(GetRunningDelegate));
            return dlgt();
        }

        public int Execute(IntPtr wnd, string cmdLine, StringBuilder outPut, uint size)
        {
            IntPtr funcAddr = this.GetFunctionAddress("");
            ExecuteDelegate dlgt =
                (ExecuteDelegate)Marshal.GetDelegateForFunctionPointer(
                funcAddr, typeof(ExecuteDelegate));
            return dlgt(wnd, cmdLine, outPut, size);
        }
        #endregion

        /// <summary>
        /// APIĂяo߂̃fQ[g擾
        /// </summary>
        /// <remarks>
        /// L\bĥ悤ɂ̂ʓ|Ƃ...
        /// </remarks>
        /// <example>
        /// <code>
        /// public ushort GetVersion()
        /// {
        ///     GetVersionDelegate dlgt = (GetVersionDelegate)this.GetDelegate("GetVersion");
        ///     return dlgt();
        /// }
        /// </code>
        /// </example>
        /// <param name="funcSuffix">API</param>
        /// <returns>fQ[g</returns>
        internal Delegate GetDelegate(string funcSuffix)
        {
            if (this.delegatesList.ContainsKey(funcSuffix))
            {
                return this.delegatesList[funcSuffix];
            }
            else
            {
                Type dtype = System.Reflection.Assembly.GetExecutingAssembly().GetType(
                    "CommonArchiverLibrary." + funcSuffix + "Delegate");
                if (dtype == null)
                {
                    throw new ApplicationException(
                        funcSuffix + "Delegate܂łB");
                }
                IntPtr funcAddr = this.GetFunctionAddress(funcSuffix);
                Delegate dlgt = Marshal.GetDelegateForFunctionPointer(funcAddr, dtype);
                this.delegatesList.Add(funcSuffix, dlgt);
                return dlgt;
            }
        }
    }
}
