using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Toolkit.Forms {
	/// <summary>
	/// ListViewItemSorter邽߂̃x[XNXB
	/// </summary>
	public abstract class ListViewSorterBase : System.Collections.IComparer {
		private int currentColumn = -1;
		private bool sortAsc = true;

		/// <summary>
		/// \[gΏۂ̃J̐ݒB
		/// </summary>
		/// <example>
		/// private void listView1_ColumnClick(object sender, ColumnClickEventArgs exception) {
		///		((ListViewSorter)listView1.ListViewItemSorter).CurrentColumn = exception.Column;
		/// 	listView1.Sort();
		/// }
		/// </example>
		public int CurrentColumn {
			set {
				sortAsc = currentColumn != value || !sortAsc;
				currentColumn = value;
			}
		}

		/// <summary>
		/// \[g̃tOZbgB
		/// Xgr[̒gSւƂɎgB
		/// </summary>
		/// <example>
		/// ((Toolkit.Forms.ListViewSorter)listView1.ListViewItemSorter).Reset();
		///	listView1.Sorting = SortOrder.None; // ǂĂĂ\[gĂ܂[ȁBB
		/// </example>
		public void Reset() {
			//CurrentColumn = -1;
			currentColumn = -1;
			sortAsc = true;
		}

		/// <summary>
		/// hNXŎrB
		/// </summary>
		protected abstract int Compare(ListViewItem x, ListViewItem y, int column);

		#region IComparer o

		public int Compare(object x, object y) {
			if (currentColumn < 0) { return 0; } // Ń\[gȂɂȂ񂾂납BB
			int cmp = Compare((ListViewItem)x, (ListViewItem)y, currentColumn);
			return sortAsc ? cmp : -cmp;
		}

		#endregion
	}

	/// <summary>
	/// ListViewSorterBaséAdelegategB
	/// </summary>
	public class ListViewSorter : ListViewSorterBase {
		public delegate int CompareDelegate(ListViewItem x, ListViewItem y, int column);

		private CompareDelegate cmp;

		public ListViewSorter(CompareDelegate cmp) {
			this.cmp = cmp;
		}

		protected override int Compare(ListViewItem x, ListViewItem y, int column) {
			return cmp(x, y, column);
		}
	}
}
