using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace Toolkit.Net.Mail {
	/// <summary>
	/// POP3
	/// </summary>
	public class POP3 : IProtocol {
		/// <summary>
		/// APOPĝǂB
		/// </summary>
		public enum APOP {
			NotUse,		// gȂ
			Try,		// gȂg
			Always,		// gȂ΃G[
		}

		APOP apop;
		int mailCount = int.MinValue; // [B擾ĂȂȂint.MinValueƂ

		/// <summary>
		/// (bZ[Wԍ + 1)  UID̕ϊ\
		/// </summary>
		Dictionary<int, string> uids = null;

		public POP3(APOP a) {
			apop = a;
		}

		#region IMailReceiveProtocol o

		public int DefaultPort(bool ssl) {
			return ssl ? 995 : 110;
		}

		public bool Login(Stream stream, string user, string pass) {
			string str = Utility.Recv(stream);
			if (apop != APOP.NotUse) {
				Match m = Regex.Match(str, "^\\+OK.+(<.+>).*$");
				if (m.Success) {
					// APOPLogin
					string md5 = Hash.MD5(Encoding.Default.GetBytes(m.Groups[1].Value + pass));
					Utility.Send(stream, "APOP " + user + " " + md5 + "\r\n");
					str = Utility.Recv(stream);
					if (str.StartsWith("+OK")) {
						ParseLoginMessage(str);
						return true;
					}
				} else {
					if (apop == APOP.Always) {
						throw new IOException("APOPF؂gpł܂ł");
					}
					// ̂܂ܕʂLoginցB
				}
			}
			// ʂLogin
			Utility.Send(stream, "USER " + user + "\r\n");
			str = Utility.Recv(stream);
			if (str.StartsWith("+OK")) {
				Utility.Send(stream, "PASS " + pass + "\r\n");
				str = Utility.Recv(stream);
				if (str.StartsWith("+OK")) {
					ParseLoginMessage(str);
					return true;
				}
			}
			return false;
		}

		public int GetMailCount(Stream stream) {
			// Ɏ擾ς݂Ȃ炻Ԃ
			if (mailCount != int.MinValue) {
				return mailCount;
			}
			// STATŎ擾
			Utility.Send(stream, "STAT\r\n");
			string str = Utility.Recv(stream);
			Match m = Regex.Match(str, "\\+OK (\\d+) .+");
			if (m.Success) {
				if (int.TryParse(m.Groups[1].Value, out mailCount)) {
					return mailCount;
				}
				mailCount = int.MinValue;
			}
			// s
			throw new IOException("[̎擾Ɏs܂ [" + str + "]");
		}

		public string ReceiveHeader(Stream stream, int n) {
			//InnerReceiveUIDL(stream);
			string str = InnerReceiveHeader(stream, n);
			return str;
		}

		public string Receive(Stream stream, int n) {
			string str = InnerReceive(stream, n);
			return str;
		}

		public string GetUniqueID(Stream stream, int n) {
			if (uids == null) {
				int mails = GetMailCount(stream);
				Utility.Send(stream, "UIDL\r\n");
				if (Utility.Recv(stream).StartsWith("+OK")) {
					Regex rg = new Regex("^\\s*(\\d)+\\s+(.+)$", RegexOptions.Compiled);
					Dictionary<int, string> tmp = new Dictionary<int, string>();
					for (int i = 0; i < mails; i++) {
						string str = Utility.Recv(stream);
						Match m = rg.Match(str);
						if (m.Success) {
							tmp.Add(int.Parse(m.Groups[1].Value), m.Groups[2].Value);
						}
					}
					System.Diagnostics.Debug.Fail("Ȃ񂩏I[L񂩁H");
					string sss = Utility.Recv(stream);
					System.Diagnostics.Debug.Fail(sss);
					// ƎMoĂۂȂ烁oփZbg
					if (0 < tmp.Count) {
						uids = tmp;
					}
				}
			}
			string uid;
			if (uids != null && uids.TryGetValue(n + 1, out uid)) {
				return uid;
			}
			throw new NotSupportedException();
		}

		public void Logout(Stream stream) {
			Utility.Send(stream, "QUIT\r\n");
			mailCount = int.MinValue;
		}

		#endregion

		/// <summary>
		/// wb_̎M
		/// </summary>
		private string InnerReceiveHeader(Stream stream, int n) {
			System.Diagnostics.Debug.Assert(0 <= n && n < mailCount);
			try {
				// wb_M̂炵̂ŎĂ݂
				Utility.Send(stream, "TOP " + (n + 1) + " 0\r\n");
				return InnerReceive(stream);
			} catch (Exception e) {
				System.Diagnostics.Debug.WriteLine("POP3(TOP Failed): " + e.Message);
				throw new NotSupportedException("POP3TOPR}h̎sɎs܂", e);
			}
		}

		/// <summary>
		/// ܂邲ƎM
		/// </summary>
		private string InnerReceive(Stream stream, int n) {
			System.Diagnostics.Debug.Assert(0 <= n && n < mailCount);
			Utility.Send(stream, "RETR " + (n + 1) + "\r\n");
			return InnerReceive(stream);
		}

		/// <summary>
		/// OCbZ[W̉
		/// </summary>
		private void ParseLoginMessage(string str) {
			Match m = Regex.Match(str, "^\\+OK .+ has (\\d+) visible messages.*$");
			if (m.Success) {
				mailCount = int.Parse(m.Groups[1].Value);
			} else {
				mailCount = int.MinValue;
			}
		}

		/// <summary>
		/// M
		/// </summary>
		private string InnerReceive(Stream stream) {
			string str = Utility.Recv(stream);
			if (!str.StartsWith("+OK")) {
				throw new IOException("[̎MɎs܂ [" + str + "]");
			}
			// M
			StringBuilder data = new StringBuilder();
			data.Append(str); // +OKĂ܂BB(L`)
			while (true) {
				int endPos = data.ToString().IndexOf("\r\n.\r\n");
				if (0 <= endPos) {
					data.Remove(endPos, data.Length - endPos); // \r\n.\r\n疖܂ō폜
					data.Append("\r\n"); // ꉞsPĂ
					break;
				}
				data.Append(Utility.Recv(stream));
			}
			data = data.Replace("\r\n..\r\n", "\r\n.\r\n");
			return data.ToString();
		}
	}
}
