using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net.Sockets;
using System.Net.Security;

namespace Toolkit.Net {
	/// <summary>
	/// [M
	/// </summary>
	public class MailReceiver : IDisposable {
		public enum SSL {
			NotUse,		// gȂ
			Try,		// gȂg
			Always,		// gȂ΃G[
		}

		string server;
		int port;

		TcpClient client = null;
		Stream stream = null;

		Mail.IProtocol protocol;

		bool loggedIn = false;

		/// <summary>
		/// wb_̃LbV
		/// </summary>
		/// <remarks>
		/// L[ɂ́A{server}\n{port}\n{user}\n{uid} gB
		/// </remarks>
		static CacheDictionary<string, string> headerCache
			= new CacheDictionary<string, string>(0x400);
			//= new CacheDictionary<string, string>(100); // eXgp
		/// <summary>
		/// {server}\n{port}\n{user}\n
		/// </summary>
		string cacheNamePrefix;

		public MailReceiver(string sv, SSL ssl, Mail.IProtocol p) {
			protocol = p;

			bool trySsl = ssl != SSL.NotUse;

			port = protocol.DefaultPort(trySsl);
			ParseServer(sv, out server, ref port);

			try {
				client = new TcpClient(server, port);
				/*
				if (!client.Connected) {
					client.Close();
					client = null;
					throw new ApplicationException(server + " ւ̐ڑɎs܂");
				}
				*/
				if (trySsl) {
					SslStream ss = new SslStream(
						new NetworkStream(client.Client), false);
					ss.AuthenticateAsClient(server);
					System.Diagnostics.Debug.Assert(ss.IsAuthenticated);
					System.Diagnostics.Debug.Assert(ss.IsEncrypted);
					if (!ss.IsAuthenticated || !ss.IsEncrypted) {
						throw new ApplicationException(server + " ƂSSLʐMɎs܂");
					}
					stream = ss;
				} else {
					stream = new NetworkStream(client.Client);
				}
			} catch {
				if (ssl == SSL.NotUse || ssl == SSL.Always) {
					throw;
				}
			}
			if (stream == null) {
				System.Diagnostics.Debug.Assert(ssl == SSL.Try);
				// SSLŃgC
				port = protocol.DefaultPort(false);
				ParseServer(sv, out server, ref port);
				client = new TcpClient(server, port);
				stream = new NetworkStream(client.Client);
			}
		}

		/*
		private bool RemoteCertificateValidater(object sender,
			System.Security.Cryptography.X509Certificates.X509Certificate certificate,
			System.Security.Cryptography.X509Certificates.X509Chain chain,
			SslPolicyErrors sslPolicyErrors) {

			switch (sslPolicyErrors) {
			case SslPolicyErrors.None:
				return true;

			case SslPolicyErrors.RemoteCertificateChainErrors:
				break;
	
			case SslPolicyErrors.RemoteCertificateNameMismatch:
				break;
	
			case SslPolicyErrors.RemoteCertificateNotAvailable:
				break;
	
			default:
				System.Diagnostics.Debug.Fail("SSL|V[");
				return false;
			}
		}
		*/

		public void Dispose() {
			if (loggedIn) {
				Logout();
			}
			// ǂǂĂׂ΂BB
			stream.Dispose();
			try {
				try {
					client.Client.Shutdown(SocketShutdown.Both);
				} catch (SocketException) {
				}
				client.Client.Disconnect(false);
			} catch (PlatformNotSupportedException) {
			}
			client.Client.Close();
			client.Close();
		}

		/// <summary>
		/// "server:port"̏ƂB
		/// </summary>
		private void ParseServer(string sv, out string server, ref int port) {
			server = sv;
			int pos = server.LastIndexOf(':');
			if (0 <= pos && pos < server.Length - 1) {
				int n;
				if (int.TryParse(server.Substring(pos + 1), out n)) {
					port = n;
					server = server.Substring(0, pos);
				}
			}
		}

		/// <summary>
		/// OC
		/// </summary>
		/// <returns>true</returns>
		public bool Login(string user, string pass) {
			if (loggedIn) {
				protocol.Logout(stream);
			}
			loggedIn = protocol.Login(stream, user, pass);
			if (loggedIn) {
				cacheNamePrefix = string.Format("{0}\n{1}\n{2}\n", server, port, user);
			}
			return loggedIn;
		}

		/// <summary>
		/// JȃbZ[W̎擾
		/// </summary>
		public int GetMailCount() {
			if (!loggedIn) {
				throw new InvalidOperationException();
			}
			return protocol.GetMailCount(stream);
		}

		/// <summary>
		/// bZ[W̎M(o邱ƂȂwb_B)
		/// </summary>
		/// <param name="n">0 ` MailCount - 1Ƃ</param>
		public string ReceiveHeader(int n) {
			if (!loggedIn) {
				throw new InvalidOperationException();
			}
			try {
				// LbV΃\B
				string uid = protocol.GetUniqueID(stream, n);
				if (string.IsNullOrEmpty(uid)) {
					return InnerReceiveHeader(n);
				}
				string cacheName = cacheNamePrefix + uid;
				string cached;
				if (headerCache.Get(cacheName, out cached)) {
					return cached;
				}
				// ۂɒʐMĎ擾
				string header = InnerReceiveHeader(n);
				// LbV
				headerCache.Add(cacheName, header);
				return header;
			} catch (NotSupportedException) {
				return InnerReceiveHeader(n);
			}
		}

		private string InnerReceiveHeader(int n) {
			try {
				return protocol.ReceiveHeader(stream, n);
			} catch (NotSupportedException e) {
				System.Diagnostics.Debug.Fail(e.Message);
				return protocol.Receive(stream, n);
			}
		}

		/// <summary>
		/// bZ[W̎M
		/// </summary>
		/// <param name="n">0 ` MailCount - 1Ƃ</param>
		public string Receive(int n) {
			if (!loggedIn) {
				throw new InvalidOperationException();
			}
			return protocol.Receive(stream, n);
		}

		/// <summary>
		/// OAEg
		/// </summary>
		public void Logout() {
			if (!loggedIn) {
				throw new InvalidOperationException();
			}
			protocol.Logout(stream);
		}
	}
}
