﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ぱすわど {
	static class Program {
		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main(string[] args) {
			using (Toolkit.App.App.Initializer app = new Toolkit.App.App.Initializer())
			using (Toolkit.AntiMultiplex multi = new Toolkit.AntiMultiplex()) {
				if (!multi.FirstRun) {
					multi.SetActive();
					return;
				}

				Application.EnableVisualStyles();
				Application.SetCompatibleTextRenderingDefault(false);

				using (ConfigManager configManager = new ConfigManager()) {
					// マスターパスワードの入力とか
					if (!configManager.IsReady) {
						InputMasterPassword(configManager);
					}
					// 成功したらメイン画面へ。
					if (configManager.IsReady) {
						using (MainForm mainForm = new MainForm(configManager)) {
							Application.Run(mainForm);
						}
					}
				}
			}
		}

		private static void InputMasterPassword(ConfigManager configManager) {
			while (true) {
				using (LoginForm loginForm = new LoginForm()) {
					//Application.Run(loginForm);
					if (loginForm.ShowDialog() == DialogResult.OK) {
						// 暗号化してるのを復元
						if (configManager.Decrypt(loginForm.Password)) {
							// 成功したらお終い。
							break;
						}
					} else {
						// キャンセル時もお終い。
						break;
					}
				}
			}
		}
	}
}